;****************************************************
;              DS1302 ̿  ð          *
;****************************************************
;
SEC	EQU	08H
MIN	EQU	09H
HOUR	EQU	0AH
DATE	EQU	0BH
DAY	EQU	0CH
MONTH	EQU	0DH
YEAR	EQU	0EH
;
BUSY_F	BIT	P0.7		; LCD Busy Flag
;
SCLK	BIT	P1.0		; DS1302 SCLK
IO	BIT	P1.1		; DS1302 I/O
RST	BIT	P1.2		; DS1302 RST
;
SW1	BIT	P1.3		; (ð   )
SW2	BIT	P1.4		; ׸ (⵵, ,  )
SW3	BIT	P1.5		;  ׸ 
SW4	BIT	P1.6		;  
;
LCD_RS	BIT	P2.0		; LCD RS
LCD_RW	BIT	P2.1		; LCD RW
LCD_CE	BIT	P2.2		; LCD CE
;
BUZZER	BIT	P2.4		; 
;
	ORG	00H		; α׷ 
	JMP	SYS_START
;
SYS_START:
        MOV	SP,#50H		;  
	CALL	LCD_INIT	; LCD ʱȭ
;
;
;*************************************************************
;*                  Է½ġ ˻                      *
;*************************************************************
;
SW_CHECK:
	JB	SW1,TIME_SET	; ð ϴ  
	JB	SW4,SEC_00	; ʸ 00 ϴ  
	CALL	DELAY1		; 10ms 
RDISP:	CALL	READ_TIME	; ð 
	CALL	DISP_TIME	;  ð LCD ÷
	JMP	SW_CHECK
;
TIME_SET:
	CALL	YEAR_SET	; ⵵ 
	CALL	MONT_SET	;  
	CALL	DATE_SET	;  
	CALL	DAY_SET		;  
	CALL	AMPM_SET	; / 
	CALL	HOUR_SET	; ð 
	CALL	MINT_SET	;  
	CALL	SECD_SET	;  
	JMP	RDISP
;
SEC_00:
	CALL	SEC_RESET	; ʸ 00 
	JMP	RDISP
;
;
;*************************************************************
;*                   LCD ʱȭ                          *
;*************************************************************
;
LCD_INIT:
	MOV	A,#38H	        ; Function Set(8bit, 5X7 dot, 2 line)
	CALL	CMD_WRITE	; 1° 
	CALL	DELAY
;
	CALL	CMD_WRITE	; 2° 
	CALL	DELAY
;
	CALL	CMD_WRITE	; 3° 
	CALL	DELAY
;
	MOV	A,#06H		; Ʈ Ʈ
	CALL	CMD_WRITE	; (巹 , Ʈ )
;
	MOV	A,#0CH		; ǥ 
	CALL	CMD_WRITE	; (ǥ on, Ŀ on,  off)
;
	MOV	A,#01H		; ȭ , Ŀ Ȩ ġ
	CALL	CMD_WRITE
	RET
;
;
;*************************************************************
;*                 ð ϴ                       *
;*************************************************************
;
YEAR_SET:			; ⵵ ϴ 
	JB	SW1,$		; ġ off  
	MOV	R2,#8EH		;   ּ(for WRITE)
	MOV	R3,#00H		; WP=0 ( 𽺿̺)
	CALL	BYTE_WRITE
;
        MOV	A,#82H		; Ŀ 1 3 ű
	CALL	CMD_WRITE
	MOV	A,#0FH		; ǥ (ǥ on, Ŀ on,  on)
	CALL	CMD_WRITE
;
YEAR_LOOP:
	JB	SW2,MONT_NEXT	;  ϴ  
	JB	SW3,YEAR_UP	; ⵵ ϴ  
	JB	SW4,YEAR_DOWN	; ⵵ ϴ  
	JMP	YEAR_LOOP
;
MONT_NEXT:
	MOV	R2,#8CH		; Year  ּ(for WRITE)
	MOV	R3,YEAR		;  ⵵ 
	CALL	BYTE_WRITE	; DS1302 
	RET
;
YEAR_UP:
	JB	SW3,$		; ġ off  
	MOV	A,YEAR
	ADD	A,#01H		; ⵵ +1 
	DA	A		; 10 
	MOV	YEAR,A
	JMP	YEAR_DISP
;
YEAR_DOWN:
	JB	SW4,$		; ġ off  
	DEC	YEAR		; ⵵ -1  (00 ~ 99)
	MOV	A,YEAR
	CJNE	A,#0FFH,CHK_YER	; 99 ˻
	MOV	YEAR,#99H
	JMP	YEAR_DISP
CHK_YER:	
	ANL	A,#00001111B
	CJNE	A,#0FH,YEAR_DISP; 0F ˻
	MOV	A,#0F9H
	ANL	A,YEAR
	MOV	YEAR,A
;
YEAR_DISP:
	MOV	A,YEAR	
	CALL	DISP_DATA	; ⵵  2ڸ LCD ǥ
        MOV	A,#82H		; Ŀ 1 3 ű
	CALL	CMD_WRITE
	JMP	YEAR_LOOP
;--------------------------------------------------------------------
MONT_SET:			;  ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#85H		; Ŀ 1 6 ű
	CALL	CMD_WRITE
;
	MOV	A,MONTH
	ANL	A,#00011111B
	MOV	MONTH,A
;
MONT_LOOP:
	JB	SW2,DATE_NEXT	;  ϴ  
	JB	SW3,MONT_UP	;  ϴ  
	JB	SW4,MONT_DOWN	;  ϴ  
	JMP	MONT_LOOP
;
DATE_NEXT:
	MOV	R2,#88H		; Month  ּ(for WRITE)
	MOV	R3,MONTH	;   
	CALL	BYTE_WRITE	; DS1302 
	RET
;
MONT_UP:
	JB	SW3,$		; ġ off  
	MOV	A,MONTH
	ADD	A,#01H		;  +1 
	DA	A		; 10 
	MOV	MONTH,A
	CJNE	A,#13H,MONT_DISP; 13 ˻
	MOV	MONTH,#01H
	JMP	MONT_DISP
;
MONT_DOWN:
	JB	SW4,$		; ġ off  
	DEC	MONTH		;  -1 
	MOV	A,MONTH
	CJNE	A,#0FH,CHK_MON	; 0FH ˻
	MOV	MONTH,#09H
	JMP	MONT_DISP
CHK_MON:
	CJNE	A,#00H,MONT_DISP; 00 ˻
	MOV	MONTH,#12H
;
MONT_DISP:
	MOV	A,MONTH
	CALL	DISP_DATA	;  LCD ǥ
        MOV	A,#85H		; Ŀ 1 6 ű
	CALL	CMD_WRITE
	JMP	MONT_LOOP
;--------------------------------------------------------------------
DATE_SET:			; ڸ ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#88H		; Ŀ 1 9 ű
	CALL	CMD_WRITE
;
	MOV	A,DATE
	ANL	A,#00111111B
	MOV	DATE,A
;
DATE_LOOP:
	JB	SW2,DAY_NEXT	;  ϴ  
	JB	SW3,DATE_UP	; ڸ ϴ  
	JB	SW4,DATE_DOWN	; ڸ ϴ  
	JMP	DATE_LOOP
;
DAY_NEXT:
	MOV	R2,#86H		; Date  ּ(for WRITE)
	MOV	R3,DATE		;   
	CALL	BYTE_WRITE	; DS1302 
	RET
;
DATE_UP:
	JB	SW3,$		; ġ off  
	MOV	A,DATE
	ADD	A,#01H		; ڸ +1 
	DA	A		; 10 
	MOV	DATE,A
	CJNE	A,#32H,DATE_DISP; 32 ˻
	MOV	DATE,#01H
	JMP	DATE_DISP
;
DATE_DOWN:
	JB	SW4,$		; ġ off  
	DEC	DATE		; ڸ -1 
	MOV	A,DATE
	CJNE	A,#00H,CHK_DAT	; 00 ˻
	MOV	DATE,#31H
	JMP	DATE_DISP
CHK_DAT:
	ANL	A,#00001111B
	CJNE	A,#0FH,DATE_DISP; 0FH ˻
	MOV	A,#0F9H
	ANL	A,DATE
	MOV	DATE,A
;
DATE_DISP:
	MOV	A,DATE
	CALL	DISP_DATA	; ڸ LCD ǥ
        MOV	A,#88H		; Ŀ 1 9 ű
	CALL	CMD_WRITE
	JMP	DATE_LOOP
;--------------------------------------------------------------------
DAY_SET:			;  ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#8BH		; Ŀ 1 12 ű
	CALL	CMD_WRITE
;
	MOV	A,DAY
	ANL	A,#00000111B
	MOV	DAY,A
;
DAY_LOOP:
	JB	SW2,AMPM_NEXT	; ð ϴ  
	JB	SW3,DAY_UP	;  ϴ  
	JB	SW4,DAY_DOWN	;  ϴ  
	JMP	DAY_LOOP
;
AMPM_NEXT:
	MOV	R2,#8AH		; Day  ּ(for WRITE)
	MOV	R3,DAY		;   
	CALL	BYTE_WRITE	; DS1302 
	RET
;
DAY_UP:
	JB	SW3,$		; ġ off  
	INC	DAY		;  +1 
	MOV	A,DAY
	CJNE	A,#08H,DAY_DISP	; 8 ˻
	MOV	DAY,#01H
	JMP	DAY_DISP
;
DAY_DOWN:
	JB	SW4,$		; ġ off  
	DEC	DAY		;  -1 
	MOV	A,DAY
	CJNE	A,#00H,DAY_DISP	; 0 ˻
	MOV	DAY,#07H
;
DAY_DISP:
	MOV	A,DAY
	CJNE	A,#01H,DAY_A
	MOV	DPTR,#MSG_SUN	; "Sun." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_A:	CJNE	A,#02H,DAY_B
	MOV	DPTR,#MSG_MON	; "Mon." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_B:	CJNE	A,#03H,DAY_C
	MOV	DPTR,#MSG_TUE	; "Tue." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_C:	CJNE	A,#04H,DAY_D
	MOV	DPTR,#MSG_WED	; "Wed." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_D:	CJNE	A,#05H,DAY_E
	MOV	DPTR,#MSG_THU	; "Thu." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_E:	CJNE	A,#06H,DAY_F
	MOV	DPTR,#MSG_FRI	; "Fri." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_F:	MOV	DPTR,#MSG_SAT	; "Sat." LCD ǥ
	CALL	DISP_MSG
;
DAY_CUR:
        MOV	A,#8BH		; Ŀ 1 12 ű
	CALL	CMD_WRITE
	JMP	DAY_LOOP
;--------------------------------------------------------------------
AMPM_SET:			; /ĸ ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#0C0H		; Ŀ 2 1 ű
	CALL	CMD_WRITE
;
AMPM_LOOP:
	JB	SW2,HOUR_NEXT	;  ϴ  
	JB	SW3,AMPM_UP	; , ĸ ϴ  
	JMP	AMPM_LOOP
;
HOUR_NEXT:
	MOV	R2,#84H		; Hours  ּ(for WRITE)
	MOV	R3,HOUR		;  ð 
	CALL	BYTE_WRITE	; DS1302 
	RET
;
AMPM_UP:
	JB	SW3,$		; ġ off  
	MOV	A,HOUR
	JB	ACC.5,AM_DISP	; /ĸ Ÿ Ʈ ˻
	SETB	ACC.5
	MOV	HOUR,A
	MOV	DPTR,#MSG_PM	; "PM " LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_CUR
;
AM_DISP:
	CLR	ACC.5
	MOV	HOUR,A
	MOV	DPTR,#MSG_AM	; "AM " LCD ǥ
	CALL	DISP_MSG
AMPM_CUR:
        MOV	A,#0C0H		; Ŀ 2 1 ű
	CALL	CMD_WRITE
	JMP	AMPM_LOOP
;--------------------------------------------------------------------
HOUR_SET:			; ð ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#0C3H		; Ŀ 2 4 ű
	CALL	CMD_WRITE
;
	MOV	A,HOUR
	ANL	A,#11100000B
	MOV	R0,A
	MOV	A,HOUR
	ANL	A,#00011111B
	MOV	HOUR,A
;
HOUR_LOOP:
	JB	SW2,MINT_NEXT	; /ĸ ϴ  
	JB	SW3,HOUR_UP	; ð ϴ  
	JB	SW4,HOUR_DOWN	; ð ϴ  
	JMP	HOUR_LOOP
;
MINT_NEXT:
	MOV	A,HOUR
	ORL	A,R0
	SETB	ACC.7		; 12 
	MOV	HOUR,A
	MOV	R2,#84H		; Hour  ּ(for WRITE)
	MOV	R3,HOUR		;  ð 
	CALL	BYTE_WRITE	; DS1302 
	RET
;
HOUR_UP:
	JB	SW3,$		; ġ off  
	MOV	A,HOUR
	ADD	A,#01H
	DA	A
	MOV	HOUR,A
	CJNE	A,#13H,HOUR_DISP; 13 ˻
	MOV	HOUR,#01H
	JMP	HOUR_DISP
;
HOUR_DOWN:
	JB	SW4,$		; ġ off  
	DEC	HOUR		; ð -1 
	MOV	A,HOUR
	CJNE	A,#00H,CHK_HUR	; 0 ˻
	MOV	HOUR,#12H
	JMP	HOUR_DISP
CHK_HUR:
	CJNE	A,#0FH,HOUR_DISP; 0F ˻
	MOV	A,#0F9H
	ANL	A,HOUR
	MOV	HOUR,A
;
HOUR_DISP:
	MOV	A,HOUR
	CALL	DISP_DATA	; ð LCD ǥ
        MOV	A,#0C3H		; Ŀ 2 4 ű
	CALL	CMD_WRITE
	JMP	HOUR_LOOP
;--------------------------------------------------------------------
MINT_SET:			;  ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#0C6H		; Ŀ 2 7 ű
	CALL	CMD_WRITE
;
	MOV	A,MIN
	ANL	A,#01111111B
	MOV	MIN,A
;
MINT_LOOP:
	JB	SW2,SECD_NEXT	; ʸ ϴ  
	JB	SW3,MINT_UP	;  ϴ  
	JB	SW4,MINT_DOWN	;  ϴ  
	JMP	MINT_LOOP
;
SECD_NEXT:
	MOV	R2,#82H		; Minutes  ּ(for WRITE)
	MOV	R3,MIN		;   
	CALL	BYTE_WRITE	; DS1302 
	RET
;
MINT_UP:
	JB	SW3,$		; ġ off  
	MOV	A,MIN
	ADD	A,#01H		;  +1 
	DA	A
	MOV	MIN,A
	CJNE	A,#60H,MINT_DISP; 60 ˻
	MOV	MIN,#00H
	JMP	MINT_DISP
;
MINT_DOWN:
	JB	SW4,$		; ġ off  
	DEC	MIN		;  -1 
	MOV	A,MIN
	CJNE	A,#0FFH,CHK_MIN	; 0FF ˻
	MOV	MIN,#59H
	JMP	MINT_DISP
CHK_MIN:
	ANL	A,#00001111B
	CJNE	A,#0FH,MINT_DISP; 0F ˻
	MOV	A,#0F9H
	ANL	A,MIN
	MOV	MIN,A
;
MINT_DISP:
	MOV	A,MIN
	CALL	DISP_DATA	;  LCD ǥ
        MOV	A,#0C6H		; Ŀ 2 7 ű
	CALL	CMD_WRITE
	JMP	MINT_LOOP
;--------------------------------------------------------------------
SECD_SET:			; ʸ ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#0C9H		; Ŀ 2 10 ű
	CALL	CMD_WRITE
;
	MOV	A,SEC
	ANL	A,#01111111B
	MOV	SEC,A
;
SECD_LOOP:
	JB	SW1,SET_END1	;  ϴ  
	JB	SW2,SET_END2	;  ϴ  
	JB	SW3,SECD_UP	; ʸ ϴ  
	JB	SW4,SECD_DOWN	; ʸ ϴ  
	JMP	SECD_LOOP
;
SET_END1:
	JB	SW1,$		; ġ off  
	JMP	EXIT
;
SET_END2:
	JB	SW2,$		; ġ off  
EXIT:	MOV	R2,#80H		; Second  ּ(for WRITE)
	MOV	R3,SEC		;   
	CALL	BYTE_WRITE	; DS1302 
	MOV	A,#0CH		; ǥ (ǥ on, Ŀ off,  off)
	CALL	CMD_WRITE
	RET
;
SECD_UP:
	JB	SW3,$		; ġ off  
	MOV	A,SEC
	ADD	A,#01H		; ʸ +1 
	DA	A
	MOV	SEC,A
	CJNE	A,#60H,SECD_DISP; 60 ˻
	MOV	SEC,#00H
	JMP	SECD_DISP
;
SECD_DOWN:
	JB	SW4,$		; ġ off  
	DEC	SEC		; ʸ -1  (0 ~ 59)
	MOV	A,SEC
	CJNE	A,#0FFH,CHK_SEC	; 59 ˻
	MOV	SEC,#59H
	JMP	SECD_DISP
CHK_SEC:
	ANL	A,#00001111B
	CJNE	A,#0FH,SECD_DISP; 0F ˻
	MOV	A,#0F9H
	ANL	A,SEC
	MOV	SEC,A
;
SECD_DISP:
	MOV	A,SEC
	CALL	DISP_DATA	; ʸ LCD ǥ
        MOV	A,#0C9H		; Ŀ 2 10 ű
	CALL	CMD_WRITE
	JMP	SECD_LOOP
;
;
;*************************************************************
;*           DS1302κ ð д                *
;*************************************************************
;
READ_TIME:
	MOV	R2,#8EH		;   ּ(for WRITE)
	MOV	R3,#00H		; WP=0 ( 𽺿̺)
	CALL	BYTE_WRITE	; DS1302 
;
	MOV	R2,#81H 	; Second  ּ(for READ)
	CALL	BYTE_READ	; DS1302κ ʸ 
	MOV	SEC,R4		; ʸ SEC 
;
	MOV	R2,#83H 	; Minite  ּ(for READ)
	CALL	BYTE_READ	; DS1302κ  
	MOV	MIN,R4		;  MIN 
;
	MOV	R2,#85H 	; Hour  ּ(for READ)
	CALL	BYTE_READ	; DS1302κ ð 
	MOV	HOUR,R4		; ð HOUR 
;
	MOV	R2,#87H 	; Date  ּ(for READ)
	CALL	BYTE_READ	; DS1302κ  
	MOV	DATE,R4		;  DATE 
;
	MOV	R2,#89H 	; Month  ּ(for READ)
	CALL	BYTE_READ	; DS1302κ  
	MOV	MONTH,R4	;  MONTH 
;
	MOV	R2,#8BH 	; Day  ּ(for READ)
	CALL	BYTE_READ	; DS1302κ  
	MOV	DAY,R4		;  DAY 
;
	MOV	R2,#8DH 	; Year  ּ(for READ)
	CALL	BYTE_READ	; DS1302κ ⵵ 
	MOV	YEAR,R4		; ⵵ YEAR 
	RET
;
;
;*************************************************************
;*           LCD ð ÷ϴ             *
;*************************************************************
;
DISP_TIME:
        MOV	A,#80H		; Ŀ 1 1 ű
	CALL	CMD_WRITE
	MOV	DPTR,#MSG1	; "20" LCD ǥ
	CALL	DISP_MSG
;
	MOV	A,YEAR		; ⵵  2ڸ ǥ
	CALL	DISP_DATA
	MOV	DPTR,#MSG2	; "." LCD ǥ
	CALL	DISP_MSG
;
	ANL	MONTH,#00011111B
	MOV	A,MONTH
	CALL	DISP_DATA	;  LCD ǥ
	MOV	DPTR,#MSG2	; "." LCD ǥ
	CALL	DISP_MSG
;
	ANL	DATE,#00111111B
	MOV	A,DATE
	CALL	DISP_DATA	; ڸ LCD ǥ
	MOV	DPTR,#MSG2	; "." LCD ǥ
	CALL	DISP_MSG
;
	ANL	DAY,#00000111B
	MOV	A,DAY
	CJNE	A,#01H,DAY_MON	; Ͽ ΰ?
	MOV	DPTR,#MSG_SUN	; "Sun." LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_MON:
	CJNE	A,#02H,DAY_TUE	; ΰ?
	MOV	DPTR,#MSG_MON	; "Mon." LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_TUE:
	CJNE	A,#03H,DAY_WED	; ȭΰ?
	MOV	DPTR,#MSG_TUE	; "Tue." LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_WED:
	CJNE	A,#04H,DAY_THU	; ΰ?
	MOV	DPTR,#MSG_WED	; "Wed." LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_THU:
	CJNE	A,#05H,DAY_FRI	; ΰ?
	MOV	DPTR,#MSG_THU	; "Thu." LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_FRI:
	CJNE	A,#06H,DAY_SAT	; ݿΰ?
	MOV	DPTR,#MSG_FRI	; "Fri." LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_SAT:
	MOV	DPTR,#MSG_SAT	; "Sat." LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
AMPM_DISP:
        MOV	A,#0C0H		; Ŀ 2 1 ű
	CALL	CMD_WRITE
;
        MOV     A,HOUR
	JB	ACC.5,PM	;   ˻
	MOV	DPTR,#MSG_AM	; "AM " LCD 
	CALL	DISP_MSG
	JMP	HOR_DISP
;
PM:	MOV	DPTR,#MSG_PM	; "PM " LCD ǥ
	CALL	DISP_MSG
;
HOR_DISP:
	MOV	A,HOUR
	ANL	A,#00011111B
	CALL	DISP_DATA	; ð LCD ǥ
	MOV	DPTR,#MSG3	;  ":" LCD ǥ
	CALL	DISP_MSG
;
	MOV	A,MIN
	ANL	A,#01111111B
	MOV	R3,A
	CALL	DISP_DATA	;  LCD ǥ
	MOV	DPTR,#MSG3	; ":" LCD ǥ
	CALL	DISP_MSG
;
	MOV	A,SEC
	ANL	A,#01111111B
	MOV	R4,A
	CALL	DISP_DATA	; ʸ LCD ǥ
;
	CJNE	R3,#00H,TIME0;
	CJNE	R4,#00H,TIME0;
	CALL	BEEP
TIME0:
	RET
;
;
;*************************************************************
;*                ʸ 00 ϴ                   *
;*************************************************************
;
SEC_RESET:
	JB	SW4,$		; ġ off  
	MOV	A,SEC
	ANL	A,#10000000B	; =00
	MOV	SEC,A
;
	MOV	R2,#8EH		;   ּ(for WRITE)
	MOV	R3,#00H		; WP=0 ( 𽺿̺)
	CALL	BYTE_WRITE	; DS1302 
;
	MOV	R2,#80H		; Second  ּ(for WRITE)
	MOV	R3,SEC		;   
	CALL	BYTE_WRITE	; DS1302 ʸ 
	RET
;
;
;*************************************************************
;*           DS1302 1Ʈ ͸               *
;*************************************************************
;
BYTE_WRITE:
	MOV	A,R2		; ּ(for Writing)
	MOV	R5,#08H		; Ʈ 
	SETB	RST		; RST = H
LOOP1:
	RRC	A
	MOV	IO,C		; I/O ּ 1Ʈ 
	SETB	SCLK		; SCLK = H
	CLR	SCLK		; SCLK = L
	DJNZ	R5,LOOP1	;  Ʈ ˻
;
	MOV	A,R3		; (for Writing)
	MOV	R5,#08H		; Ʈ 
LOOP2:
	RRC	A
	MOV	IO,C		; I/O  1Ʈ 
	SETB	SCLK		; SCLK = H
	CLR	SCLK		; SCLK = L
	DJNZ	R5,LOOP2	;  Ʈ ˻
	NOP
	CLR	RST		; RST = L
	RET
;
;
;*************************************************************
;*          DS1302κ 1Ʈ ͸ д           *
;*************************************************************
;
BYTE_READ:
	MOV	A,R2		; ּ(for Reading)
	MOV	R5,#07H		; Ʈ  - 1
	SETB	RST		; RST = H
LOOP3:
	RRC	A
	MOV	IO,C		; I/O ּ 1Ʈ 
	SETB	SCLK		; SCLK = H
	CLR	SCLK		; SCLK = L
	DJNZ	R5,LOOP3
	RRC	A
	MOV	IO,C		; 8° Ʈ I/O 
	SETB	SCLK		; SCLK = H
;
	MOV	R5,#08H		; Ʈ 
LOOP4:
	CLR	SCLK		; SCLK = L
	MOV	C,IO		; I/Oκ  1Ʈ Է
	RRC	A
	SETB	SCLK		; SCLK = H
	DJNZ	R5,LOOP4	;  Ʈ ˻
	MOV	R4,A		;  ʹ R4 
	NOP
	CLR	RST		; RST = L
	RET
;
;
;*************************************************************
;*               LCD ɾ  ƾ                    *
;*************************************************************
;
CMD_WRITE:
	MOV	P0,A      	; CPU --> LCD
	CLR	LCD_RS        	; RS=L (ɾ)
	CLR	LCD_RW        	; R/W=L ()
	NOP
	SETB	LCD_CE        	; LCD ο̺
	NOP
	NOP
	CLR	LCD_CE        	; LCD 𽺿̺
	CALL	LCD_BUSY  	; LCD Ϸ  
	RET
;
;
;*************************************************************
;*              LCD ͸  ƾ                     *
;*************************************************************
;
DATA_WRITE:
	MOV	P0,A      	; CPU --> LCD
	SETB	LCD_RS        	; RS=H ()
	CLR	LCD_RW        	; R/W=L ()
	NOP
	SETB	LCD_CE        	; LCD ο̺
	NOP
	NOP
	CLR	LCD_CE        	; LCD 𽺿̺
	CALL	LCD_BUSY  	; LCD Ϸ  
	RET
;
;
;*************************************************************
;*             LCD Busy Flag Check Routine                   *
;*************************************************************
;
LCD_BUSY:
	CLR	LCD_CE		; LCD 𽺿̺
	SETB	BUSY_F		; Busy Flag=H
	SETB	LCD_RW		; R/W=H (б)
	CLR	LCD_RS		; RS=L (ɾ)
LB1:	CLR	LCD_CE		; LCD 𽺿̺
	SETB	LCD_CE		; LCD ο̺
	JB	BUSY_F,LB1	; Busy Flag ˻
	CLR	LCD_CE		; Busy Flag 0̸ LCD 𽺿̺
	RET
;
;
;*************************************************************
;*             ð ͸ LCD ǥϴ ƾ             *
;*************************************************************
;
DISP_DATA:
	MOV	R1,A
        SWAP    A
        ANL     A,#00001111B
        MOV     R2,A		;  4Ʈ 
        MOV     A,R1
        ANL     A,#00001111B
        MOV     R1,A		;  4Ʈ 
;
        MOV	A,R2
	ADD	A,#30H		; ASCII ڵ ȯ
        CALL    DATA_WRITE	;  4Ʈ LCD ǥ
;
        MOV	A,R1
	ADD	A,#30H		; ASCII ڵ ȯ
        CALL    DATA_WRITE	;  4Ʈ LCD ǥ
	RET
;
;
;*************************************************************
;*                ޽ LCD ǥϴ ƾ               *
;*************************************************************
;
DISP_MSG:
	CLR	A		; A=0
	MOVC	A,@A+DPTR	; ͸ 
	INC	DPTR		; DPTR 
	JZ	END_MSG		;   ˻
	CALL	DATA_WRITE	; LCD ͸ 
	JMP	DISP_MSG	;  
END_MSG:
	RET
;
;
;*************************************************************
;*                ø ︮ BEEP                 *
;*************************************************************
;
BEEP:
	CLR	BUZZER		;  on
	MOV	R1,#00H
BEP1:	MOV	R0,#00H
	DJNZ	R0,$
	DJNZ	R1,BEP1
	SETB	BUZZER		;  off
	RET
;
;*************************************************************
;*              ƾ                                     *
;*************************************************************
;
DELAY:	
	MOV	R1,#00H
DLY1:	MOV	R0,#00H
	DJNZ	R0,$
	DJNZ	R1,DLY1
	RET
;
DELAY1:				; 10ms delay
	MOV	R1,#25
DLY2:	MOV	R0,#198
	DJNZ	R0,$
	DJNZ	R1,DLY2
	RET
;
MSG1:		DB	'20',00H	; 20 of 2009
MSG2:		DB	'.',00H		; 00H   ǹ
MSG3:		DB	':',00H
;
MSG_SUN:	DB	'Sun',00H	; Sunday
MSG_MON:	DB	'Mon',00H	; Monday
MSG_TUE:	DB	'Tue',00H	; Tuesday
MSG_WED:	DB	'Wed',00H	; Wednesday
MSG_THU:	DB	'Thu',00H	; Thursday
MSG_FRI:	DB	'Fri',00H	; Friday
MSG_SAT:	DB	'Sat',00H	; Saturday
;
MSG_AM:		DB	'AM ',00H	; AM
MSG_PM:		DB	'PM ',00H	; PM
        END				; α׷ 
