;****************************************************
;            DS12C887 ̿  ð          *
;****************************************************
;
RTC_SEC	EQU	00H		; RTC time, date registers
RTC_MIN	EQU	02H		; DS12C887  ּ
RTC_HOR	EQU	04H
RTC_DAY	EQU	06H
RTC_DAT	EQU	07H
RTC_MON	EQU	08H
RTC_YER	EQU	09H
;
REGA	EQU	0AH		; RTC control registers
REGB	EQU	0BH		; DS12C887  ּ
;
TEMP	EQU	08H
;
BUSY_F	BIT	P0.7		; LCD Busy Flag
;
SW1	BIT	P1.0		; (ð   )
SW2	BIT	P1.1		; ׸ (⵵, ,  )
SW3	BIT	P1.2		;  ׸ 
SW4	BIT	P1.3		;  
RTC_CS	BIT	P1.7		; DS12C887 CS
;
LCD_RS	BIT	P2.0		; LCD RS
LCD_RW	BIT	P2.1		; LCD RW
LCD_CE	BIT	P2.2		; LCD CE
;
BUZZER	BIT	P2.4		; 
;
	ORG	00H		; α׷ 
	JMP	SYS_START
;
SYS_START:
        MOV	SP,#50H		;  
	CALL	LCD_INIT	; LCD ʱȭ
	CALL	RTC_INIT	; DS12C887 ʱȭ
;
;
;*************************************************************
;*                  Է½ġ ˻                      *
;*************************************************************
;
SW_CHECK:
	JB	SW1,TIME_SET	; ð ϴ  
	JB	SW4,SEC_00	; ʸ 00 ϴ  
	CALL	DELAY1		; 10ms 
RDISP:	CALL	DISP_TIME	; ð о LCD ÷
	JMP	SW_CHECK
;
TIME_SET:
	CALL	YEAR_SET
	CALL	MONT_SET
	CALL	DATE_SET
	CALL	DAY_SET
	CALL	AMPM_SET
	CALL	HOUR_SET
	CALL	MINT_SET
	CALL	SECD_SET
	JMP	RDISP
;
SEC_00:
	CALL	SEC_RESET
	JMP	RDISP
;
;
;*************************************************************
;*                   LCD ʱȭ                          *
;*************************************************************
;
LCD_INIT:
	MOV	A,#38H	        ; Function Set(8bit, 5X7 dot, 2 line)
	CALL	CMD_WRITE	; 1° 
	CALL	DELAY
;
	CALL	CMD_WRITE	; 2° 
	CALL	DELAY
;
	CALL	CMD_WRITE	; 3° 
	CALL	DELAY
;
	MOV	A,#06H		; Ʈ Ʈ
	CALL	CMD_WRITE	; (巹 , Ʈ )
;
	MOV	A,#0CH		; ǥ 
	CALL	CMD_WRITE	; (ǥ on, Ŀ on,  off)
;
	MOV	A,#01H		; ȭ , Ŀ Ȩ ġ
	CALL	CMD_WRITE
	RET
;
;
;*************************************************************
;*               DS12C887 ʱȭ                         *
;*************************************************************
;
RTC_INIT:
	CLR	RTC_CS
	MOV	DPTR,#REGA	;  A ʱȭ
	MOV	A,#00101111B	;  on, SQW=2Hz
	MOVX	@DPTR,A
;
	MOV	DPTR,#REGB	;  B ʱȭ
	MOV	A,#00000000B	; 12, BCD, ͷƮ 𽺿̺
	MOVX	@DPTR,A
	SETB	RTC_CS
	RET
;
;
;*************************************************************
;*                 ð ϴ                       *
;*************************************************************
;
YEAR_SET:			; ⵵ ϴ 
	JB	SW1,$		; ġ off  
        MOV	A,#82H		; Ŀ 1 3 ű
	CALL	CMD_WRITE
	MOV	A,#0FH		; ǥ (ǥ on, Ŀ on,  on)
	CALL	CMD_WRITE
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_YER	; Year  ּ
	MOVX	A,@DPTR		; ⵵ 
	SETB	RTC_CS
	MOV	TEMP,A		; ⵵ TEMP 
;
YEAR_LOOP:
	JB	SW2,MONT_NEXT	;  ϴ  
	JB	SW3,YEAR_UP	; ⵵ ϴ  
	JB	SW4,YEAR_DOWN	; ⵵ ϴ  
	JMP	YEAR_LOOP
;
MONT_NEXT:
	CLR	RTC_CS
	MOV	DPTR,#RTC_YER	; Year  ּ
	MOV	A,TEMP		;  ⵵ 
	MOVX	@DPTR,A		; DS12C887 
	SETB	RTC_CS
	RET
;
YEAR_UP:
	JB	SW3,$		; ġ off  
	MOV	A,TEMP
	ADD	A,#01H		; ⵵ +1 
	DA	A		; 10 
	MOV	TEMP,A
	JMP	YEAR_DISP
;
YEAR_DOWN:
	JB	SW4,$		; ġ off  
	DEC	TEMP		; ⵵ -1  (00 ~ 99)
	MOV	A,TEMP
	CJNE	A,#0FFH,CHK_YER	; 99 ˻
	MOV	TEMP,#99H
	JMP	YEAR_DISP
CHK_YER:	
	ANL	A,#00001111B
	CJNE	A,#0FH,YEAR_DISP; 0FH ˻
	MOV	A,#0F9H
	ANL	A,TEMP
	MOV	TEMP,A
;
YEAR_DISP:
	MOV	A,TEMP	
	CALL	DISP_DATA	; ⵵  2ڸ LCD ǥ
        MOV	A,#82H		; Ŀ 1 3 ű
	CALL	CMD_WRITE
	JMP	YEAR_LOOP
;--------------------------------------------------------------------
MONT_SET:			;  ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#85H		; Ŀ 1 6 ű
	CALL	CMD_WRITE
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_MON	; Month  ּ
	MOVX	A,@DPTR		;  
	SETB	RTC_CS
	ANL	A,#1FH
	MOV	TEMP,A		;  TEMP 
;
MONT_LOOP:
	JB	SW2,DATE_NEXT	;  ϴ  
	JB	SW3,MONT_UP	;  ϴ  
	JB	SW4,MONT_DOWN	;  ϴ  
	JMP	MONT_LOOP
;
DATE_NEXT:
	CLR	RTC_CS
	MOV	DPTR,#RTC_MON	; Month  ּ
	MOV	A,TEMP		;   
	MOVX	@DPTR,A		; DS12C887 
	SETB	RTC_CS
	RET
;
MONT_UP:
	JB	SW3,$		; ġ off  
	MOV	A,TEMP
	ADD	A,#01H		;  +1 
	DA	A		; 10 
	MOV	TEMP,A
	CJNE	A,#13H,MONT_DISP; 13 ˻
	MOV	TEMP,#01H
	JMP	MONT_DISP
;
MONT_DOWN:
	JB	SW4,$		; ġ off  
	DEC	TEMP		;  -1 
	MOV	A,TEMP
	CJNE	A,#0FH,CHK_MON	; 0FH ˻
	MOV	TEMP,#09H
	JMP	MONT_DISP
CHK_MON:
	CJNE	A,#00H,MONT_DISP; 00H ˻
	MOV	TEMP,#12H
;
MONT_DISP:
	MOV	A,TEMP
	CALL	DISP_DATA	;  LCD ǥ
        MOV	A,#85H		; Ŀ 1 6 ű
	CALL	CMD_WRITE
	JMP	MONT_LOOP
;--------------------------------------------------------------------
DATE_SET:			; ڸ ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#88H		; Ŀ 1 9 ű
	CALL	CMD_WRITE
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_DAT	; Date  ּ
	MOVX	A,@DPTR		; ڸ 
	SETB	RTC_CS
	ANL	A,#3FH
	MOV	TEMP,A		; ڸ TEMP 
;
DATE_LOOP:
	JB	SW2,DAY_NEXT	;  ϴ  
	JB	SW3,DATE_UP	; ڸ ϴ  
	JB	SW4,DATE_DOWN	; ڸ ϴ  
	JMP	DATE_LOOP
;
DAY_NEXT:
	CLR	RTC_CS
	MOV	DPTR,#RTC_DAT	; Date  ּ
	MOV	A,TEMP		;   
	MOVX	@DPTR,A		; DS12C887 
	SETB	RTC_CS
	RET
;
DATE_UP:
	JB	SW3,$		; ġ off  
	MOV	A,TEMP
	ADD	A,#01H		; ڸ +1 
	DA	A		; 10 
	MOV	TEMP,A
	CJNE	A,#32H,DATE_DISP; 32H ˻
	MOV	TEMP,#01H
	JMP	DATE_DISP
;
DATE_DOWN:
	JB	SW4,$		; ġ off  
	DEC	TEMP		; ڸ -1 
	MOV	A,TEMP
	CJNE	A,#00H,CHK_DAT	; 00H ˻
	MOV	TEMP,#31H
	JMP	DATE_DISP
CHK_DAT:
	ANL	A,#00001111B
	CJNE	A,#0FH,DATE_DISP; 0FH ˻
	MOV	A,#0F9H
	ANL	A,TEMP
	MOV	TEMP,A
;
DATE_DISP:
	MOV	A,TEMP
	CALL	DISP_DATA	; ڸ LCD ǥ
        MOV	A,#88H		; Ŀ 1 9 ű
	CALL	CMD_WRITE
	JMP	DATE_LOOP
;--------------------------------------------------------------------
DAY_SET:			;  ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#8BH		; Ŀ 1 12 ű
	CALL	CMD_WRITE
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_DAY	; Day  ּ
	MOVX	A,@DPTR		;  
	SETB	RTC_CS
	ANL	A,#07H
	MOV	TEMP,A		;  TEMP 
;
DAY_LOOP:
	JB	SW2,AMPM_NEXT	; ð ϴ  
	JB	SW3,DAY_UP	;  ϴ  
	JB	SW4,DAY_DOWN	;  ϴ  
	JMP	DAY_LOOP
;
AMPM_NEXT:
	CLR	RTC_CS
	MOV	DPTR,#RTC_DAY	; Day  ּ
	MOV	A,TEMP		;   
	MOVX	@DPTR,A		; DS12C887 
	SETB	RTC_CS
	RET
;
DAY_UP:
	JB	SW3,$		; ġ off  
	INC	TEMP		;  +1 
	MOV	A,TEMP
	CJNE	A,#08H,DAY_DISP	; 8 ˻
	MOV	TEMP,#01H
	JMP	DAY_DISP
;
DAY_DOWN:
	JB	SW4,$		; ġ off  
	DEC	TEMP		;  -1 
	MOV	A,TEMP
	CJNE	A,#00H,DAY_DISP	; 0 ˻
	MOV	TEMP,#07H
;
DAY_DISP:
	MOV	A,TEMP
	CJNE	A,#01H,DAY_A
	MOV	DPTR,#MSG_SUN	; "Sun." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_A:	CJNE	A,#02H,DAY_B
	MOV	DPTR,#MSG_MON	; "Mon." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_B:	CJNE	A,#03H,DAY_C
	MOV	DPTR,#MSG_TUE	; "Tue." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_C:	CJNE	A,#04H,DAY_D
	MOV	DPTR,#MSG_WED	; "Wed." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_D:	CJNE	A,#05H,DAY_E
	MOV	DPTR,#MSG_THU	; "Thu." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_E:	CJNE	A,#06H,DAY_F
	MOV	DPTR,#MSG_FRI	; "Fri." LCD ǥ
	CALL	DISP_MSG
	JMP	DAY_CUR
DAY_F:	MOV	DPTR,#MSG_SAT	; "Sat." LCD ǥ
	CALL	DISP_MSG
;
DAY_CUR:
        MOV	A,#8BH		; Ŀ 1 12 ű
	CALL	CMD_WRITE
	JMP	DAY_LOOP
;--------------------------------------------------------------------
AMPM_SET:			; /ĸ ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#0C0H		; Ŀ 2 1 ű
	CALL	CMD_WRITE
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_HOR	; Hours  ּ
	MOVX	A,@DPTR		; ð 
	SETB	RTC_CS
	MOV	TEMP,A		; ð TEMP 
;
AMPM_LOOP:
	JB	SW2,HOUR_NEXT	;  ϴ  
	JB	SW3,AMPM_UP	; , ĸ ϴ  
	JMP	AMPM_LOOP
;
HOUR_NEXT:
	CLR	RTC_CS
	MOV	DPTR,#RTC_HOR	; Hours  ּ
	MOV	A,TEMP		;  ð 
	MOVX	@DPTR,A		; DS12C887 
	SETB	RTC_CS
	RET
;
AMPM_UP:
	JB	SW3,$		; ġ off  
	MOV	A,TEMP
	JB	ACC.7,AM_DISP	; /ĸ Ÿ Ʈ ˻
	SETB	ACC.7
	MOV	TEMP,A
	MOV	DPTR,#MSG_PM	; "PM " LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_CUR
;
AM_DISP:
	CLR	ACC.7
	MOV	TEMP,A
	MOV	DPTR,#MSG_AM	; "AM " LCD ǥ
	CALL	DISP_MSG
AMPM_CUR:
        MOV	A,#0C0H		; Ŀ 2 1 ű
	CALL	CMD_WRITE
	JMP	AMPM_LOOP
;--------------------------------------------------------------------
HOUR_SET:			; ð ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#0C3H		; Ŀ 2 4 ű
	CALL	CMD_WRITE
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_HOR	; Hours  ּ
	MOVX	A,@DPTR		; ð 
	SETB	RTC_CS
	MOV	TEMP,A
	ANL	A,#10000000B	; AM/PM Ʈ ũ
	MOV	R0,A
	MOV	A,TEMP
	ANL	A,#01111111B
	MOV	TEMP,A		; ð TEMP 
;
HOUR_LOOP:
	JB	SW2,MINT_NEXT	; /ĸ ϴ  
	JB	SW3,HOUR_UP	; ð ϴ  
	JB	SW4,HOUR_DOWN	; ð ϴ  
	JMP	HOUR_LOOP
;
MINT_NEXT:
	MOV	A,TEMP
	ORL	A,R0
	MOV	TEMP,A
	CLR	RTC_CS
	MOV	DPTR,#RTC_HOR	; Hours  ּ
	MOV	A,TEMP		;  ð 
	MOVX	@DPTR,A		; DS12C887 
	SETB	RTC_CS
	RET
;
HOUR_UP:
	JB	SW3,$		; ġ off  
	MOV	A,TEMP
	ADD	A,#01H
	DA	A
	MOV	TEMP,A
	CJNE	A,#13H,DISP_HOR; 13 ˻
	MOV	TEMP,#01H
	JMP	DISP_HOR
;
HOUR_DOWN:
	JB	SW4,$		; ġ off  
	DEC	TEMP		; ð -1 
	MOV	A,TEMP
	CJNE	A,#00H,CHK_HUR	; 0 ˻
	MOV	TEMP,#12H
	JMP	DISP_HOR
CHK_HUR:
	CJNE	A,#0FH,DISP_HOR; 0FH ˻
	MOV	A,#0F9H
	ANL	A,TEMP
	MOV	TEMP,A
;
DISP_HOR:
	MOV	A,TEMP
	CALL	DISP_DATA	; ð LCD ǥ
        MOV	A,#0C3H		; Ŀ 2 4 ű
	CALL	CMD_WRITE
	JMP	HOUR_LOOP
;--------------------------------------------------------------------
MINT_SET:			;  ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#0C6H		; Ŀ 2 7 ű
	CALL	CMD_WRITE
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_MIN	; Minutes  ּ
	MOVX	A,@DPTR		;  
	SETB	RTC_CS
	ANL	A,#7FH
	MOV	TEMP,A		;  TEMP 
;
MINT_LOOP:
	JB	SW2,SECD_NEXT	; ʸ ϴ  
	JB	SW3,MINT_UP	;  ϴ  
	JB	SW4,MINT_DOWN	;  ϴ  
	JMP	MINT_LOOP
;
SECD_NEXT:
	CLR	RTC_CS
	MOV	DPTR,#RTC_MIN	; Minutes  ּ
	MOV	A,TEMP		;   
	MOVX	@DPTR,A		; DS12C887 
	SETB	RTC_CS
	RET
;
MINT_UP:
	JB	SW3,$		; ġ off  
	MOV	A,TEMP
	ADD	A,#01H		;  +1 
	DA	A
	MOV	TEMP,A
	CJNE	A,#60H,MINT_DISP; 60 ˻
	MOV	TEMP,#00H
	JMP	MINT_DISP
;
MINT_DOWN:
	JB	SW4,$		; ġ off  
	DEC	TEMP		;  -1 
	MOV	A,TEMP
	CJNE	A,#0FFH,CHK_MIN	; FFH ˻
	MOV	TEMP,#59H
	JMP	MINT_DISP
CHK_MIN:
	ANL	A,#00001111B
	CJNE	A,#0FH,MINT_DISP; 0FH ˻
	MOV	A,#0F9H
	ANL	A,TEMP
	MOV	TEMP,A
;
MINT_DISP:
	MOV	A,TEMP
	CALL	DISP_DATA	;  LCD ǥ
        MOV	A,#0C6H		; Ŀ 2 7 ű
	CALL	CMD_WRITE
	JMP	MINT_LOOP
;--------------------------------------------------------------------
SECD_SET:			; ʸ ϴ 
	JB	SW2,$		; ġ off  
        MOV	A,#0C9H		; Ŀ 2 10 ű
	CALL	CMD_WRITE
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_SEC	; Second  ּ
	MOVX	A,@DPTR		; ʸ 
	SETB	RTC_CS
	ANL	A,#7FH
	MOV	TEMP,A		; ʸ TEMP 
;
SECD_LOOP:
	JB	SW1,SET_END1	;  ϴ  
	JB	SW2,SET_END2	;  ϴ  
	JB	SW3,SECD_UP	; ʸ ϴ  
	JB	SW4,SECD_DOWN	; ʸ ϴ  
	JMP	SECD_LOOP
;
SET_END1:
	JB	SW1,$		; ġ off  
	JMP	EXIT
;
SET_END2:
	JB	SW2,$		; ġ off  
EXIT:	CLR	RTC_CS
	MOV	DPTR,#RTC_SEC	; Minutes  ּ
	MOV	A,TEMP		;   
	MOVX	@DPTR,A		; DS12C887 
	SETB	RTC_CS
	MOV	A,#0CH		; LCD ǥ 
	CALL	CMD_WRITE	; ǥ on, Ŀ off,  off
	RET
;
SECD_UP:
	JB	SW3,$		; ġ off  
	MOV	A,TEMP
	ADD	A,#01H		; ʸ +1 
	DA	A
	MOV	TEMP,A
	CJNE	A,#60H,SECD_DISP; 60 ˻
	MOV	TEMP,#00H
	JMP	SECD_DISP
;
SECD_DOWN:
	JB	SW4,$		; ġ off  
	DEC	TEMP		; ʸ -1  (0 ~ 59)
	MOV	A,TEMP
	CJNE	A,#0FFH,CHK_SEC	; 59 ˻
	MOV	TEMP,#59H
	JMP	SECD_DISP
CHK_SEC:
	ANL	A,#00001111B
	CJNE	A,#0FH,SECD_DISP; 0FH ˻
	MOV	A,#0F9H
	ANL	A,TEMP
	MOV	TEMP,A
;
SECD_DISP:
	MOV	A,TEMP
	CALL	DISP_DATA	; ʸ LCD ǥ
        MOV	A,#0C9H		; Ŀ 2 10 ű
	CALL	CMD_WRITE
	JMP	SECD_LOOP
;
;
;*************************************************************
;*       ð о LCD ÷ϴ          *
;*************************************************************
;
DISP_TIME:
        MOV	A,#80H		; Ŀ 1 1 ű
	CALL	CMD_WRITE
	MOV	DPTR,#MSG1	; "20" LCD ǥ
	CALL	DISP_MSG
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_YER	; ⵵ 
	MOVX	A,@DPTR
	SETB	RTC_CS
	CALL	DISP_DATA	; ⵵  2ڸ ǥ
	MOV	DPTR,#MSG2	; "." LCD ǥ
	CALL	DISP_MSG
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_MON	;  
	MOVX	A,@DPTR
	SETB	RTC_CS
	CALL	DISP_DATA	;  LCD ǥ
	MOV	DPTR,#MSG2	; "." LCD ǥ
	CALL	DISP_MSG
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_DAT	; ڸ 
	MOVX	A,@DPTR
	SETB	RTC_CS
	CALL	DISP_DATA	; ڸ LCD ǥ
	MOV	DPTR,#MSG2	; "." LCD ǥ
	CALL	DISP_MSG
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_DAY	;  
	MOVX	A,@DPTR
	SETB	RTC_CS
	CJNE	A,#01H,DAY_MON	; Ͽ ΰ?
	MOV	DPTR,#MSG_SUN	; "Sun" LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_MON:
	CJNE	A,#02H,DAY_TUE	; ΰ?
	MOV	DPTR,#MSG_MON	; "Mon" LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_TUE:
	CJNE	A,#03H,DAY_WED	; ȭΰ?
	MOV	DPTR,#MSG_TUE	; "Tue" LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_WED:
	CJNE	A,#04H,DAY_THU	; ΰ?
	MOV	DPTR,#MSG_WED	; "Wed" LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_THU:
	CJNE	A,#05H,DAY_FRI	; ΰ?
	MOV	DPTR,#MSG_THU	; "Thu" LCD ǥ
	CALL	DISP_MSG
	JMP	AMPM_DISP
;
DAY_FRI:
	CJNE	A,#06H,DAY_SAT	; ݿΰ?
	MOV	DPTR,#MSG_FRI
	CALL	DISP_MSG	; "Fri" LCD ǥ
	JMP	AMPM_DISP
;
DAY_SAT:
	MOV	DPTR,#MSG_SAT
	CALL	DISP_MSG	; "Sat" LCD ǥ
	JMP	AMPM_DISP
;
AMPM_DISP:
        MOV	A,#0C0H		; Ŀ 2 1 ű
	CALL	CMD_WRITE
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_HOR	; ð 
	MOVX	A,@DPTR
	SETB	RTC_CS
	JB	ACC.7,PM	;   ˻
	MOV	DPTR,#MSG_AM
	CALL	DISP_MSG	; "AM " LCD 
	JMP	HOUR_DISP
;
PM:	MOV	DPTR,#MSG_PM
	CALL	DISP_MSG	; "PM " LCD ǥ
;
HOUR_DISP:
	CLR	RTC_CS
	MOV	DPTR,#RTC_HOR	; ð 
	MOVX	A,@DPTR
	SETB	RTC_CS
	ANL	A,#01111111B
	CALL	DISP_DATA	; ð LCD ǥ
	MOV	DPTR,#MSG3
	CALL	DISP_MSG	;  ":" LCD ǥ
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_MIN	;  
	MOVX	A,@DPTR
	SETB	RTC_CS
	MOV	R3,A
	CALL	DISP_DATA	;  LCD ǥ
	MOV	DPTR,#MSG3
	CALL	DISP_MSG	; ":" LCD ǥ
;
	CLR	RTC_CS
	MOV	DPTR,#RTC_SEC	; ʸ 
	MOVX	A,@DPTR
	SETB	RTC_CS
	MOV	R4,A
	CALL	DISP_DATA	; ʸ LCD ǥ
;
	CJNE	R3,#00H,TIME0;
	CJNE	R4,#00H,TIME0;
	CALL	BEEP
TIME0:
	RET
;
;
;*************************************************************
;*                ʸ 00 ϴ                   *
;*************************************************************
;
SEC_RESET:
	JB	SW4,$		; ġ off  
	CLR	RTC_CS
	MOV	DPTR,#RTC_SEC	; Minutes  ּ
	MOV	A,#00H		; =0
	MOVX	@DPTR,A		; DS12C887 
	SETB	RTC_CS
	RET
;
;
;*************************************************************
;*               LCD ɾ  ƾ                    *
;*************************************************************
;
CMD_WRITE:
	MOV	P0,A      	; 8051 --> LCD
	CLR	LCD_RS        	; RS=L (ɾ)
	CLR	LCD_RW        	; R/W=L ()
	NOP
	SETB	LCD_CE        	; LCD ο̺
	NOP
	NOP
	CLR	LCD_CE        	; LCD 𽺿̺
	CALL	LCD_BUSY  	; LCD Ϸ  
	RET
;
;
;*************************************************************
;*              LCD ͸  ƾ                     *
;*************************************************************
;
DATA_WRITE:
	MOV	P0,A      	; 8051 --> LCD
	SETB	LCD_RS        	; RS=H ()
	CLR	LCD_RW        	; R/W=L ()
	NOP
	SETB	LCD_CE        	; LCD ο̺
	NOP
	NOP
	CLR	LCD_CE        	; LCD 𽺿̺
	CALL	LCD_BUSY  	; LCD Ϸ  
	RET
;
;
;*************************************************************
;*             LCD Busy Flag Check Routine                   *
;*************************************************************
;
LCD_BUSY:
	CLR	LCD_CE		; LCD 𽺿̺
	SETB	BUSY_F		; Busy Flag=H
	SETB	LCD_RW		; R/W=H (б)
	CLR	LCD_RS		; RS=L (ɾ)
LB1:	CLR	LCD_CE		; LCD 𽺿̺
	SETB	LCD_CE		; LCD ο̺
	JB	BUSY_F,LB1	; Busy Flag ˻
	CLR	LCD_CE		; Busy Flag 0̸ LCD 𽺿̺
	RET
;
;
;*************************************************************
;*             ð ͸ LCD ǥϴ ƾ             *
;*************************************************************
;
DISP_DATA:
	MOV	R1,A
        SWAP    A
        ANL     A,#00001111B
        MOV     R2,A		;  4Ʈ 
        MOV     A,R1
        ANL     A,#00001111B
        MOV     R1,A		;  4Ʈ 
;
        MOV	A,R2
	ADD	A,#30H		; ASCII ڵ ȯ
        CALL    DATA_WRITE	;  4Ʈ LCD ǥ
;
        MOV	A,R1
	ADD	A,#30H		; ASCII ڵ ȯ
        CALL    DATA_WRITE	;  4Ʈ LCD ǥ
	RET
;
;
;*************************************************************
;*                ޽ LCD ǥϴ ƾ               *
;*************************************************************
;
DISP_MSG:
	CLR	A		; A=0
	MOVC	A,@A+DPTR	; Move Data @A+DPTR
	INC	DPTR		; DPTR Increment
	JZ	END_MSG		; If A=0, End of Data
	CALL	DATA_WRITE	; Jump Routine for Writing LCD
	JMP	DISP_MSG	; Next Data
END_MSG:
	RET
;
;*************************************************************
;*                ø ︮ BEEP                 *
;*************************************************************
;
BEEP:
	CLR	BUZZER
	MOV	R1,#00H
BEP1:	MOV	R0,#00H
	DJNZ	R0,$
	DJNZ	R1,BEP1
	SETB	BUZZER
	RET
;
;*************************************************************
;*              ƾ                                     *
;*************************************************************
;
DELAY:	
	MOV	R1,#00H
DLY1:	MOV	R0,#00H
	DJNZ	R0,$
	DJNZ	R1,DLY1
	RET
;
DELAY1:				; 10ms delay
	MOV	R1,#25
DLY2:	MOV	R0,#198
	DJNZ	R0,$
	DJNZ	R1,DLY2
	RET
;
;
MSG1:		DB	'20',00H	; 20 of 2009
MSG2:		DB	'.',00H		; 00H   ǹ
MSG3:		DB	':',00H
;
MSG_SUN:	DB	'Sun',00H	; Sunday
MSG_MON:	DB	'Mon',00H	; Monday
MSG_TUE:	DB	'Tue',00H	; Tuesday
MSG_WED:	DB	'Wed',00H	; Wednesday
MSG_THU:	DB	'Thu',00H	; Thursday
MSG_FRI:	DB	'Fri',00H	; Friday
MSG_SAT:	DB	'Sat',00H	; Saturday
;
MSG_AM:		DB	'AM ',00H	; AM
MSG_PM:		DB	'PM ',00H	; PM
        END				; α׷ 
