// ļ ī(Frequency Counter)

#include <reg51.h>

sbit unit_4=P1^0;		// 4511 Ĩ ο̺(1000 )
sbit unit_3=P1^1;		// 4511 Ĩ ο̺(100 )
sbit unit_2=P1^2;		// 4511 Ĩ ο̺(10 )
sbit unit_1=P1^3;		// 4511 Ĩ ο̺(1 )

sbit hz_led=P1^4;		// Hz  LED
sbit khz_led=P1^5;		// KHz  LED

sbit pt3=P1^6;			// Ҽ(xx.xx) ÷
sbit pt2=P1^7;			// Ҽ(xxx.x) ÷

unsigned char index, count;
unsigned int freq_h, freq_l, frequency;

void disp_freq(void)			// ļ ÷ϴ Լ
{
	unsigned char digit1, digit2, digit3, digit4;
	unsigned int temp;

	freq_h=TH0;
	freq_l=TL0;
	frequency=freq_h<<8;
	frequency=frequency | freq_l;

	digit4=frequency/1000;		// 1,000  
	temp=frequency%1000;
	digit3=temp/100;		// 100  
	temp=temp%100;
	digit2=temp/10;			// 10  
	digit1=temp%10;			// 1  

	P2=digit4;			// 1,000   ǥ
	unit_4=0;			// 4511 ͸ ġ
	unit_4=1;

	P2=digit3;			// 100   ǥ
	unit_3=0;			// 4511 ͸ ġ
	unit_3=1;

	P2=digit2;			// 10   ǥ
	unit_2=0;			// 4511 ͸ ġ
	unit_2=1;

	P2=digit1;			// 1   ǥ
	unit_1=0;			// 4511 ͸ ġ
	unit_1=1;
}

void time_const_set(void)		//  Լ(0.001)
{
	TH1=0xfc;			// 65536-1000=FC18H
	TL1=0x18;
	TH0=0;
	TL0=0;
	EA=1;				// ü ͷƮ ο̺
	TR0=1;				// ī0 Run
	TR1=1;				// Ÿ̸1 Run
}

void TMR1_int(void) interrupt 3		// Ÿ̸/ī 1 ͷƮ  ȣ = 3
{
	if (index==0) {
		EA=0;			// ͷƮ 𽺿̺
		TR0=0;			// ī0 Stop
		TR1=0;			// Ÿ̸1 Stop
		freq_h=TH0;
		freq_l=TL0;
		frequency=freq_h << 8;
		frequency=frequency | freq_l;

		if (frequency<10) {
			hz_led=0;	// LED(Hz) on
			khz_led=1;	// LED(KHz) off
			index=1;	// 0 ~ 9999Hz 
			TH1=0x3c;	//  缳(=0.05sec)
			TL1=0xb0;	// 65536-50000=3CB0H
			TH0=0;
			TL0=0;
			count=20;	// 0.05x20=1
			EA=1;		// ü ͷƮ ο̺
			TR0=1;		// ī0 Run
			TR1=1;		// Ÿ̸1 Run
		}
		else if (frequency<100) {
			hz_led=1;	// LED(Hz) off
			khz_led=0;	// LED(KHz) on
			index=2;	// 10.00 ~ 99.99KHz 
			TH1=0x3c;	//  缳(=0.05sec)
			TL1=0xb0;	// 65536-50000=3CB0H
			TH0=0;
			TL0=0;
			count=2;	// 0.05x2=0.1
			EA=1;		// ü ͷƮ ο̺
			TR0=1;		// ī0 Run
			TR1=1;		// Ÿ̸1 Run
		}
		else if (frequency<1000) {
			hz_led=1;	// LED(Hz) off
			khz_led=0;	// LED(KHz) on
			index=3;	// 100.0 ~ 999.9KHz 
			TH1=0xd8;	//  缳(=0.01sec)
			TL1=0xf0;	// 65536-10000=D8F0H
			TH0=0;
			TL0=0;
			EA=1;		// ü ͷƮ ο̺
			TR0=1;		// ī0 Run
			TR1=1;		// Ÿ̸1 Run
		}
		else {			// frequency >= 1000 
			hz_led=1;	// LED(Hz) off
			khz_led=0;	// LED(KHz) on
			index=4;	// 1000 ~ 9999KHz 
			TH1=0xfc;	//  缳(=0.001sec)
			TL1=0x18;	// 65536-1000=FC18H
			TH0=0;
			TL0=0;
			EA=1;		// ü ͷƮ ο̺
			TR0=1;		// ī0 Run
			TR1=1;		// Ÿ̸1 Run
		}
	}
	else if (index==1) {
		count=count-1;
		if (count==0) {
			EA=0;		// ͷƮ 𽺿̺
			TR0=0;		// ī0 Stop
			TR1=0;		// Ÿ̸1 Stop
			pt3=0;		// Dot(xx.xx) off
			pt2=0;		// Dot(xxx.x) off
			disp_freq();	// ļ ÷
			time_const_set();	//  (0.001)
			index=0;
		}
		else {
			TH1=0x3c;	//  缳(=0.05sec)
			TL1=0xb0;	// 65536-50000=3CB0H
		}
	}
	else if (index==2) {
		count=count-1;
		if (count==0) {
			EA=0;		// ͷƮ 𽺿̺
			TR0=0;		// ī0 Stop
			TR1=0;		// Ÿ̸1 Stop
			pt3=1;		// Dot(xx.xx) on
			pt2=0;		// Dot(xxx.x) off
			disp_freq();	// ļ ÷
			time_const_set();	//  (0.001)
			index=0;
		}
		else {
			TH1=0x3c;	//  缳(=0.05sec)
			TL1=0xb0;	// 65536-50000=3CB0H
		}
	}
	else if (index==3) {
		EA=0;			// ͷƮ 𽺿̺
		TR0=0;			// ī0 Stop
		TR1=0;			// Ÿ̸1 Stop
		pt3=0;			// Dot(xx.xx) off
		pt2=1;			// Dot(xxx.x) on
		disp_freq();		// ļ ÷
		time_const_set();	//  (0.001)
		index=0;
	}
	else if (index==4) {
		EA=0;			// ͷƮ 𽺿̺
		TR0=0;			// ī0 Stop
		TR1=0;			// Ÿ̸1 Stop
		pt3=0;			// Dot(xx.xx) off
		pt2=0;			// Dot(xxx.x) off
		disp_freq();		// ļ ÷
		time_const_set();	//  (0.001)
		index=0;
	}
	return;
}

void main(void)
{
	index=0;
	TMOD=0x15;		// Ÿ̸1( 1), ī0( 1)
	time_const_set();	//  (0.001)
	ET1=1;			// Ÿ̸ 1 ͷƮ ο̺
	ET0=1;			// ī 0 ͷƮ ο̺
	while(1);		// ͷƮ 
}