// SHT71 ̿ ½

#include <reg51.h>
#include <math.h>

unsigned char Data_H, Data_L, RH_true;
signed int t_C;
char *ptr;			// 

sbit busy_flag=P1^7;		// LCD  ˻ ÷
sbit LCD_RS=P2^0;		// LCD RS
sbit LCD_RW=P2^1;		// LCD RW
sbit LCD_CE=P2^2;		// LCD CE
sbit DATA=P2^4;
sbit SCK=P2^5;

code unsigned char MSG1[]="Temperat: ";
code unsigned char MSG2[]="+";
code unsigned char MSG3[]="-";
code unsigned char MSG4[]="C"; 			// 
code unsigned char MSG5[]="Humidity: ";
code unsigned char MSG6[]="%";

code unsigned int so_rh_tbl[]={0x0064,0x007C,0x0095,0x00AE,
	0x00C8,0x00E1,0x00FB,0x0114,0x012E,0x0148,0x0162,0x017C,
	0x0196,0x01B0,0x01CA,0x01E5,0x01FF,0x021A,0x0235,0x0250,
	0x026B,0x0286,0x02A1,0x02BC,0x02D7,0x02F3,0x030F,0x032A,
	0x0346,0x0362,0x037E,0x039B,0x03B7,0x03D3,0x03F0,0x040D,
	0x042A,0x0447,0x0464,0x0481,0x049F,0x04BC,0x04DA,0x04F8,
	0x0516,0x0534,0x0552,0x0571,0x0590,0x05AE,0x05CD,0x05ED,
	0x060C,0x062B,0x064B,0x066B,0x068B,0x06AB,0x06CC,0x06EC,
	0x070D,0x072E,0x074F,0x0771,0x0792,0x07B4,0x07D6,0x07F9,
	0x081B,0x083E,0x0861,0x0884,0x08A8,0x08CB,0x08EF,0x0914,
	0x0938,0x095D,0x0982,0x09A7,0x09CD,0x09F3,0x0A19,0x0A40,
	0x0A67,0x0A8E,0x0AB6,0x0ADD,0x0B06,0x0B2E,0x0B58,0x0B81,
	0x0BAB,0x0BD5,0x0C00,0x0C2B,0x0C57,0x0C83,0x0CAF,0x0CDC};

code unsigned int rh_lin_tbl[]={0x0061,0x00C5,0x0128,0x018E,
	0x01F1,0x0256,0x02B8,0x031D,0x0382,0x03E6,0x044A,0x04AE,
	0x0511,0x0574,0x05DA,0x063C,0x06A1,0x0706,0x076B,0x07CF,
	0x0833,0x0896,0x08F9,0x095C,0x09C2,0x0A27,0x0A88,0x0AED,
	0x0B51,0x0BB4,0x0C1B,0x0C7E,0x0CE0,0x0D45,0x0DAA,0x0E0F,
	0x0E73,0x0ED6,0x0F39,0x0F9F,0x1001,0x1066,0x10CA,0x112E,
	0x1191,0x11F4,0x125A,0x12BF,0x1320,0x1384,0x13EB,0x144E,
	0x14B0,0x1515,0x157A,0x15DE,0x1641,0x16A7,0x1709,0x176E,
	0x17D1,0x1835,0x189B,0x18FD,0x1961,0x19C5,0x1A2B,0x1A8E,
	0x1AF2,0x1B56,0x1BBA,0x1C1F,0x1C81,0x1CE5,0x1D4B,0x1DAE,
	0x1E13,0x1E76,0x1ED9,0x1F3E,0x1FA2,0x2006,0x206B,0x20CF,
	0x2132,0x2197,0x21F9,0x225F,0x22C1,0x2327,0x238A,0x23EF,
	0x2452,0x24B7,0x251A,0x257F,0x25E3,0x2646,0x26AA,0x270F};

void delay(unsigned char i)    // ª ð Լ
{
	while(i--);
}

void delay_long(unsigned int i)	//  ð Լ
{
	while(i--);
}

void lcd_busy(void)		//  ÷׸ ˻ϴ Լ
{
	unsigned char busy;

	LCD_CE=0;		// LCD 𽺿̺
	busy_flag=1;		// P1.7=High
	LCD_RW=1;		// R/W=High(Read)
	LCD_RS=0;		// LCD_RS=L(Instruction)
	do {
		busy=P1;
		LCD_CE=0;
		LCD_CE=1;
	} while(busy&=0x80);
	LCD_CE=0;		// LCD 𽺿̺
}

void cmd_write(unsigned char Command)	// LCD ɾ  Լ
{
	P1=Command;
	LCD_RS=0;		// LCD_RS=Low(Instruction)
	LCD_RW=0;		// R/W=Low(Write)
	LCD_CE=1;		// LCD ο̺
	LCD_CE=0;		// LCD 𽺿̺
	lcd_busy();
}

void data_write(unsigned char Byte)	// LCD ͸  ƾ
{
	P1=Byte;
	LCD_RS=1;		// LCD_RS=High(Data)
	LCD_RW=0;		// R/W=Low(Write)
	LCD_CE=1;		// LCD ο̺
	LCD_CE=0;		// LCD 𽺿̺
	lcd_busy();
}

void lcd_initialze(void)	// LCD ʱȭ
{
	cmd_write(0x38);	//  (8Ʈ, 5x7Ʈ, 2)
	delay_long(0x0200);	// (4.1ms ̻)
	cmd_write(0x38);
	delay_long(0x08);	// (100us ̻)
	cmd_write(0x38);
	cmd_write(0x0c);	// ÷  ɾ(÷ on, Ŀ off,  off)
	cmd_write(0x06);	// Ʈ  (巹 , Ʈ )
	cmd_write(0x01);	// ÷ Ŭ, Ŀ Ȩ ġ
}

void disp_data(unsigned char Byte)	// ͸ LCD ÷ϴ Լ
{
  	data_write((Byte/10)+0x30);	// LCD  4Ʈ ÷
  	data_write((Byte%10)+0x30);	// LCD  4Ʈ ÷
}

void disp_msg(void)		// ޽ LCD ǥϴ Լ
{
	char *str;
	str=ptr;
	do {
 		data_write(*str);
		str++;
	} while(*str);
}

void write_byte(unsigned char Byte)	// SHT71  
{
	unsigned char i;
	for (i=0x80; i>0; i/=2) { 	// ũ  Ʈ
		if (i & Byte) DATA=1;
		else DATA=0;
		SCK=1; 		// SCK=High
		SCK=0;		// SCK=Low
	}
	while(DATA); 		// DATA  
	SCK=1; 			// ACK  9° Ŭ
	SCK=0;
	DATA=1;
	while(DATA);
}

void read_byte(void)		// SHT71κ  б
{
	unsigned char i;
	Data_H=0;
	for (i=0x80; i>0; i/=2) {		// ũ  Ʈ
		if (DATA) Data_H=(Data_H | i); 	// 1Ʈ 
		SCK=1; 				// SCK=High
		SCK=0;				// SCK=Low
	}
	DATA=0; 				// Ʈ  ACK
	SCK=1; 					// ACK  9° SCK
	SCK=0;
	DATA=1;

	Data_L=0;
	for (i=0x80; i>0; i/=2) {		// ũ  Ʈ
		if (DATA) Data_L=(Data_L | i); 	// 1Ʈ 
		SCK=1; 				// SCK=High
		SCK=0;				// SCK=Low
	}
	DATA=1;
	SCK=1;
	SCK=0;
}

void trans_start(void)
{
	DATA=1; 	SCK=0; 	// ʱ 
	delay(1);	SCK=1;
	delay(1);	DATA=0;
	delay(1);	SCK=0;
	delay(3);	SCK=1;
	delay(1);	DATA=1;
	delay(1);	SCK=0;
}

void conn_reset(void)
{
	unsigned char i;
	DATA=1; SCK=0; 		// ʱ 
	for (i=0; i<9; i++) {	// 9SCK Ŭ
		SCK=1;
		delay(1);
		SCK=0;
	}
}

void measure_temp(void)		// µ  Լ
{
	unsigned char imsi;
	int so_t;

	trans_start(); 		//   
	write_byte(0x03);	// µ  
	read_byte();		// Data_H( Ʈ), Data_L( Ʈ)

	so_t=Data_H & 0x3f;	// 14Ʈ ͸ 
	so_t=so_t << 8;
	so_t=so_t | Data_L;
	t_C=(so_t-4000)/100; 	// µ []

	cmd_write(0x80);	// Ŀ 1 1 ű
	ptr=MSG1;		// LCD 'Temperat: ' ÷
	disp_msg();
	imsi=t_C & 0x80;
	if (imsi==0) {
		ptr=MSG2;	// LCD '+' ÷,  µ
		disp_msg();
		disp_data(t_C);	// LCD µ ÷
	}
	else {
		ptr=MSG3;	// LCD '-' ÷,  µ
		disp_msg();
		t_C=~t_C+1;	// 2 
		disp_data(t_C);	// µ LCD ǥ
	}
	data_write(0xdf);	// LCD '' ÷
	ptr=MSG4;		// LCD '' ÷
	disp_msg();
}

void measure_humi(void)		//  Լ
{
	unsigned char i;
	signed int so_rh, RH_linear, imsi;

	trans_start(); 		//   
	write_byte(0x05);	//   
	read_byte();		// Data_H(Ʈ), Data_L(Ʈ)
	Data_H=Data_H & 0x0f;	// 12Ʈ ͸ 
	so_rh=Data_H << 8;
	so_rh=so_rh | Data_L;

	for (i=0; i<100; i++) {
		if (so_rh <= so_rh_tbl[i]) break;
	}
	RH_linear=rh_lin_tbl[i];
	imsi=(t_C-25)*(1000+8*so_rh)/1000+RH_linear;
	RH_true=imsi/100;

	cmd_write(0xc0);	// Ŀ 2 1 ű
	ptr=MSG5;		// LCD 'Humidity: ' ÷
	disp_msg();
	disp_data(RH_true);	// LCD  ÷
	ptr=MSG6;		// LCD '%' ÷
	disp_msg();
}

void main(void)
{
	lcd_initialze();	// LCD ʱȭ
	conn_reset();		//   

	do {
		measure_temp(); 	// µ  ÷
		measure_humi();		//   ÷
		delay_long(0x4b00);	// (210ms ̻)
	} while(1);    	
}